// helpers.h
// where else should I put them?
// v0.84 (7.3.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 
//          by:

#ifndef HELPERS_H
#define HELPERS_H

#include "classes.h"
#include <qobject.h>

// the standard(STL) strings are "encrypted" by a simple
// bijective mapping so that especially the servername
// cannot be read so easily in the cye.datafile
#include <string>
using std::string;
string encrypt(string &original);
string decrypt(string &encrypted);
// When string is << and >> to/from QDatastream,
// it is encrypted, when << to Textstream, it is plain characters
#include <qdatastream.h>
#include <qtextstream.h>
QDataStream& operator<< (QDataStream &s, string str);
QTextStream& operator<< (QTextStream &s, string str);
QDataStream& operator>> (QDataStream &s, string &str);


#include<qlistview.h>
void invertOrderOf(QListViewItem *LV, QListViewItem *last);
void invertOrder(QListViewItem *first, QListViewItem *last);

int minOf2(int a, int b) ;
int maxOf2(int a, int b) ;

#include<qobject.h>
#include<qwidget.h>
#include<qtimer.h>
#include<qmap.h>


struct cellCoord {
	uint row;
	uint column;
	cellCoord::cellCoord(){};
	cellCoord::cellCoord(uint r, uint c) : row(r), column(c) {};
	friend bool operator<(const cellCoord &a, const cellCoord &b){
		return a.row!=b.row ? (a.row<b.row) : (a.column<b.column) ;
	}
	friend cellCoord nextCellForEditing(uint r, uint c);
};


class TimedCell : public QObject {
	Q_OBJECT
private:
	cellCoord cell;
	QTimer * theTimer;
public:
	TimedCell(cellCoord theCell, int msec, QObject *parent, const char *name );
	TimedCell::~TimedCell();
	void stop();
	bool isActive();

private slots:
	void timeout();

signals:
	void timeIsOut (cellCoord);
};



class AutoErasedCells : public QObject
// TODO: it doesn't seem to free the memory 
// when shrunk to zero size again (?).
{
	Q_OBJECT
public:
	AutoErasedCells ( QObject *parent=0, const char *name=0 );
	void insert(cellCoord aCell);
	void remove(cellCoord aCell);
	bool isActive(cellCoord aCell);
	
private slots:
	void finished(cellCoord aCell);

signals:
	void eraseCell(cellCoord);

private:
	QMap<cellCoord, TimedCell*> Timers;
};

#include <qstring.h>

QString errorMessageAndSolution( uint errnum );

int copyFile(QString from, QString to);

void openBrowser(QString target);

// These two are just used to get rid of the stupid 
// g++ warning "unused variable"
int doNothing(int dummy);
QString doNothing(const QString &dummy);

bool isEmail(QString s);

bool is_it_Windows(); // true=Windows, false=Other (_WIN32 not defined)

#endif // HELPERS_H





